<Query Kind="Program" />

void Main()
{
	string[] names = { "Michael", "Jennifer", "Clementine", "Marcus" };
	
	Skip (names, 2).Dump();
}

IEnumerable<T> Skip<T> (IEnumerable<T> input, int count)
{
	return input.SelectMany (
		(element, i) => i >= count 
			? new[] { element } 
			: new T[0]);
}