<Query Kind="Program" />

void Main()
{
	"foo".ToEnumerable().Dump();
}

static class Extensions
{
	public static IEnumerable<T> ToEnumerable<T> (this T element)
	{
		return Enumerable.Repeat (element, 1);
	}
	
	public static Nullable<U> Bind<T,U> (this Nullable<T> input, Func<T, U> func) 
	{
		if (!input.HasValue) return Null;
		return func (input);
	}
}