<Query Kind="Program" />

void Main()
{
	Impure<int> money = 3;
	Impure<int> rifle = 4;
	
	var product = money.Bind (m => rifle.Bind (r => r * m));
	product.Dump("product");
}

class Impure<T>
{
	readonly T _value;

	public Impure (T value) { _value = value; }
	
	public static implicit operator Impure<T> (T value) { return new Impure<T> (value); }
	
	public override string ToString() { return "An impure " + _value.ToString(); }
	
	public Impure<U> Bind<U> (Func<T, U> func)
	{
		return (Impure<U>) func(_value);
	}
	
	public Impure<U> Bind<U> (Func<T, Impure<U>> func)
	{
		return func(_value);
	}
}