<Query Kind="Program" />

void Main()
{
	var foo1 = new Foo ("Foo1", () => foo2);
	var foo2 = new Foo ("Foo2", () => foo1);
	
	foo1.Dump();
	foo2.Dump();
}

class Foo
{
	readonly string _name;
	readonly Lazy<Foo> _other;

	public string Name { get { return _name; } }	
	public Foo Other { get { return _other.Value; } }
	
	public Foo (string name, Func<Foo> other)
	{
		_name = name;
		_other = new Lazy<Foo> (other);
	}
}