<Query Kind="Program" />

void Main()
{
	double? x = 3;
	x.Bind (Math.Sqrt).Bind (Math.Sin).Dump();	
}

static class Extensions
{
	public static U? Bind<T,U> (this T? value, Func<T, U> func) where T:struct where U:struct
	{
		return Bind (value, x => (U?) func (x));
	}

	public static U? Bind<T,U> (this T? value, Func<T, U?> func) where T:struct where U:struct
	{
		if (!value.HasValue) return default(U?);
		return func(value.Value);
	}
}