<Query Kind="Program" />

void Main()
{
	string[] names = { "John", "Mary", "Joe", "Sally", "Nicola", "Bec" };
	
	Where (names, n => !n.Contains ('y')).Dump();
}

IEnumerable<T> Where<T> (IEnumerable<T> input, Func<T, bool> predicate)
{
	foreach (var element in input)
		if (predicate (element))
			yield return element;
}