<Query Kind="Program" />

void Main()
{
	string[] names = { "Michael", "Jennifer", "Clementine", "Marcus" };
	
	Select (names, n => n.ToUpper()).Dump();
}

IEnumerable<TResult> Select<T,TResult> (IEnumerable<T> input, Func<T, TResult> selector)
{
	return input.SelectMany (element => new[] { selector (element) });
}