<Query Kind="Program" />

void Main()
{
	string[] names = { "John", "Mary", "Joe", "Sally", "Nicola", "Bec" };
	
	var list = new List<string>();
	
	foreach (string s in names)
		if (!s.Contains ('y'))
			list.Add (s);
			
	list.Sort(new StringLengthComparer());
	list.Dump();
}

class StringLengthComparer : IComparer<string>
{
	public int Compare (string s1, string s2)
	{
		int lengthComparison = s1.Length.CompareTo (s2.Length);
		if (lengthComparison != 0) return lengthComparison;
		return s1.CompareTo(s2);
	}
}
