<Query Kind="Program" />

void Main()
{
	var memoizer = new Memoizer();
	memoizer.GetValue (2).Dump();
	memoizer.GetValue (2).Dump();
	memoizer.GetValue (2).Dump();
}

static int Expensive (int x) { Thread.Sleep(2000); return x * 10; }

class Memoizer
{
	readonly Dictionary<int,int> _cache = new Dictionary<int,int>();
	
	public int GetValue (int x)
	{
		int result;
		if (_cache.TryGetValue (x, out result)) return result;
		return _cache[x] = Expensive (x);
	}
}